/*
	*
	* CArchiveBranch.hpp - NewBreeze CArchiveBranch Class Header
	*
*/

#pragma once

#include <QtWidgets>

class CArchiveBranch : public QObject {
	Q_OBJECT

	public:
		CArchiveBranch();
		CArchiveBranch( QString, QIcon, QString, CArchiveBranch *parent = 0 );

		int branchCount();

		void clearBranches();

		void addBranch( CArchiveBranch* );
		void removeBranch( CArchiveBranch* );

		CArchiveBranch* branch( int );
		CArchiveBranch* branch( QString );
		QList<CArchiveBranch*> branches();

		QVariant data( int role ) const;
		bool setData( int column, QVariant data );

		CArchiveBranch *parent();
		int row();

		void sort();

		QString name();
		QString size();
		QIcon icon();

	private:
		QList<CArchiveBranch*> mBranches;
		CArchiveBranch *parentNode;

		QString mPath;
		QIcon mIcon;
		QString mSize;

		QStringList __nameFilters;
		bool __showHidden;
};

bool caseInsensitiveNameSort( CArchiveBranch *first, CArchiveBranch *second );
